Subject: [netmod] Éric Vyncke's No Objection on draft-ietf-netmod-yang-instance-file-format-19: (with COMMENT)

From: Éric Vyncke via Datatracker <[email-masked]>
Date: Tue, 05 Oct 2021 04:27:24 -0700

Éric Vyncke has entered the following ballot position for
draft-ietf-netmod-yang-instance-file-format-19: No Objection

When responding, please keep the subject line intact and reply to all
email addresses included in the To and CC lines. (Feel free to cut this
introductory paragraph, however.)

Please refer to https://www.ietf.org/blog/handling-iesg-ballot-positions/
for more information about how to handle DISCUSS and COMMENT positions.

The document, along with other ballot positions, can be found here:
https://datatracker.ietf.org/doc/draft-ietf-netmod-yang-instance-file-format/

----------------------------------------------------------------------
COMMENT:
----------------------------------------------------------------------

Thank you for the work put into this document.

Please find below some non-blocking COMMENT points (but replies would be
appreciated even if only for my own education), and some nits.

I hope that this helps to improve the document,

Regards,

-éric

== COMMENTS ==

Generic comment about the use of the word "file" (which means an object in a
file system for me) rather than something more generic (no suggestion to offer
though) ?

-- Section 1 --
The first 2 sentences are quite repetitive.

Is it about "offline delivery" or "exchange" ? At this point of reading the
document, it is still unclear in my mind what it is about... The rest of the
I-D made it clear.

Unclear which UC is either implemented or potential (even with the appendix);
could also add forward references to the appendix UC). Should the
implementation(s) be referenced if they are public ?

-- Section 1.1 --
Unsure why a "data set" should be named? The choice of words does not seem the
best fit (even though if I have no suggestions).

-- Section 2 --
Like some other ADs, I wonder why "The context data part MUST... except" is not
a "SHOULD" as there are exceptions.

What is the expected behaviour when the timestamp in the filename does not
match the meta data ?

-- Section 2.1 --
There is a "SHOULD" so when are exceptions/deviations acceptable ?

The description of "simplified" is really too simple ;-)

I would also appreciate that the order of the list matches the following
sub-sections order.

Thank you for using RFC 8792.

-- Section 4 --
Did the authors think about adding the party creating the file and adding an
optional signature in the file itself?

== NITS ==

-- Section 1 --
The first 2 sentences are quite repetitive. Missing "." At the end of the 1st §

Why is "Factory Default Setting" capitalised ?

-- Section 1.2 --
Why using the future tense "shall be" rather than "are" ?

-- Section 2.1.1 and others --
Suggest to warn the reader that the examples are further in the text in a
different section.

-- Section 6 --
A "," is missing.

---

From: Balázs Lengyel <[email-masked]>
Date: Tue, 5 Oct 2021 16:10:23 +0000

Hello Eric,
Thank you for the thorough review. I used many of your comments to improve the draft. See my detailed answers below as BALAZS:
Regards Balazs

-----Original Message-----
From: Éric Vyncke via Datatracker <[email-masked]> 
Sent: 2021. október 5., kedd 13:27
To: The IESG <[email-masked]>
Cc: [email-masked]; [email-masked]; [email-masked]; Kent Watsen <[email-masked]>; [email-masked]
Subject: Éric Vyncke's No Objection on draft-ietf-netmod-yang-instance-file-format-19: (with COMMENT)

When responding, please keep the subject line intact and reply to all email addresses included in the To and CC lines. (Feel free to cut this introductory paragraph, however.)

Please find below some non-blocking COMMENT points (but replies would be appreciated even if only for my own education), and some nits.

Regards,

-éric

== COMMENTS ==

Generic comment about the use of the word "file" (which means an object in a file system for me) rather than something more generic (no suggestion to offer
though) ?
BALAZS: In most cases we do actually mean an object in a file system. 
In some cases not: In UC6 Allowing YANG instance data to be carried within  other IPC message formats. 
This is the exact reason while we differentiate between an instance-data-set and an instance-data-file. 
An instance-data-set may be contained in a file, but may be transferred in a protocol message.

-- Section 1 --
The first 2 sentences are quite repetitive.
BALAZS: The first sentence states that we need such data off-lie
The second sentence states that this offline data may be needed in 3 different phases design, implementation or even later after the server and the YANG module is up and running, I just don't have access to it.
Reworded to clarify this.

Is it about "offline delivery" or "exchange" ? At this point of reading the document, it is still unclear in my mind what it is about... The rest of the I-D made it clear.
BALAZS: The draft is only about defining a format for YANG instance data. 
Naturally once you have a data format it could be used both to deliver the information offline in a file or to exchange information using the format in an protocol message.
Most use-cases mentioned are about Offline delivery.
.

Unclear which UC is either implemented or potential (even with the appendix); could also add forward references to the appendix UC). Should the
implementation(s) be referenced if they are public ?
BALAZS:  As stated in section 1. Use cases are listed only as examples. This draft is only about defining a format for YANG Instance Data.
I know UC1,2,3 are already implemented by more than one company, but as this draft is only about the format, I don't think we should reference the implementations. 
Also, UC1 is already utilized in 2 other internet drafts.

-- Section 1.1 --
Unsure why a "data set" should be named? The choice of words does not seem the best fit (even though if I have no suggestions).
BALAZS: Specific data sets need to be identified. What is it about? When was it prepared? 
 I want a way to identify the specific data set. So, we give it a name (and a revision/timestamp).  This is why its named.
Any better suggestion?

-- Section 2 --
Like some other ADs, I wonder why "The context data part MUST... except" is not a "SHOULD" as there are exceptions.

What is the expected behaviour when the timestamp in the filename does not match the meta data ?
BALAZS: We are following RFC7950 in which YANG related file names are recommended with a SHOULD but not prescribed with a MUST.
Some people wanted to use separate timestamps when the instance-data-set is created and when it is put into an instance-data-file.
This draft does not prescribe an expected behavior of the tools, it just defines the format.

-- Section 2.1 --
There is a "SHOULD" so when are exceptions/deviations acceptable ?
BALAZS: Based on your and Murray's comments, this will be changed to MUST.

The description of "simplified" is really too simple ;-)
BALAZS: Added  "only the module name and revision-date is used "

I would also appreciate that the order of the list matches the following sub-sections order.
BALAZS: OK, updated.

-- Section 4 --
Did the authors think about adding the party creating the file and adding an optional signature in the file itself?
BALAZS:  Not specifically. A basic format is defined, but it is indicated in section 2, that:
"Some metadata items are defined in the YANG module "ietf-yang-instance-data", but other items MAY be used."

== NITS ==

-- Section 1 --
The first 2 sentences are quite repetitive. Missing "." At the end of the 1st §
BALAZS: The first sentence states that we need such data off-lie
The second sentence states that this offline data may be needed in 3 different phases design, implementation or even later after the server and the YANG module is up and running, I just don't have access to it.
Reworded to clarify this.
Added last full stop.

Why is "Factory Default Setting" capitalised ?
BALAZS: OK, I decapitalize it (If there is such a word  :-)  ).

-- Section 1.2 --
Why using the future tense "shall be" rather than "are" ?
BALAZS: The principles are not facts that just exists, they are rather goals we fulfill by defining this format. . I though "shall" would be the correct   term.

-- Section 2.1.1 and others --
Suggest to warn the reader that the examples are further in the text in a different section.
BALAZS: OK, will add it.

-- Section 6 --
A "," is missing.
BALAZS: OK, will correct it

---

From: "Eric Vyncke (evyncke)" <[email-masked]>
Date: Tue, 5 Oct 2021 21:19:09 +0000

Hello Balázs,

Thank you for your quick reply and your actions. My comments are non-blocking anyway ;-) see my replies prefixed with EV>

Regards

-éric

On 05/10/2021, 18:10, "iesg on behalf of Balázs Lengyel" <[email-masked] on behalf of balazs.lengyel=[email-masked]> wrote:

    Hello Eric,

    -----Original Message-----
    From: Éric Vyncke via Datatracker <[email-masked]> 
    Sent: 2021. október 5., kedd 13:27
    To: The IESG <[email-masked]>
    Cc: [email-masked]; [email-masked]; [email-masked]; Kent Watsen <[email-masked]>; [email-masked]
    Subject: Éric Vyncke's No Objection on draft-ietf-netmod-yang-instance-file-format-19: (with COMMENT)

    Regards,

    -éric

    == COMMENTS ==

EV> indeed, so, should the title be updated s/file/data set/ ?

    -- Section 1 --

EV> thanks

EV> nice to know, next time, you may want to have an 'implementation status' section (to be removed by the RFC editor).

    -- Section 1.1 --
    Unsure why a "data set" should be named? The choice of words does not seem the best fit (even though if I have no suggestions).
    BALAZS: Specific data sets need to be identified. What is it about? When was it prepared? 
EV> correct but it is also in the meta-data part (if not mistaken)
     I want a way to identify the specific data set. So, we give it a name (and a revision/timestamp).  This is why its named.
    Any better suggestion?

    -- Section 2 --

    -- Section 2.1 --

EV> thanks

    -- Section 4 --

    == NITS ==

    -- Section 1 --

EV> I do not know either ;-)

    -- Section 1.2 --

    -- Section 6 --
    A "," is missing.

---

From: Balázs Lengyel <[email-masked]>
Date: Wed, 6 Oct 2021 09:03:13 +0000

Hello Eric,
See some more answers as BALAZS2.
Regards Balazs

-----Original Message-----
From: Eric Vyncke (evyncke) <evyncke=[email-masked]> 
Sent: 2021. október 5., kedd 23:19
To: Balázs Lengyel <[email-masked]>; The IESG <[email-masked]>; Benoit Claise <[email-masked]>
Cc: [email-masked]; Kent Watsen <[email-masked]>; [email-masked]; [email-masked]
Subject: Re: Éric Vyncke's No Objection on draft-ietf-netmod-yang-instance-file-format-19: (with COMMENT)

Hello Balázs,

Regards

-éric

    Hello Eric,

    -----Original Message-----
    From: Éric Vyncke via Datatracker <[email-masked]> 
    Sent: 2021. október 5., kedd 13:27
    To: The IESG <[email-masked]>
    Cc: [email-masked]; [email-masked]; [email-masked]; Kent Watsen <[email-masked]>; [email-masked]
    Subject: Éric Vyncke's No Objection on draft-ietf-netmod-yang-instance-file-format-19: (with COMMENT)

    Regards,

    -éric

    == COMMENTS ==

EV> indeed, so, should the title be updated s/file/data set/ ?
BALAZS2: I am reluctant to change the title this late in the process. Although your suggestion is reasonable, people might more easily recognize what an instance-data-file is than an what an instance-data-set means.

    -- Section 1 --

EV> thanks

    -- Section 1.1 --
BALAZS2: Yes the name should be contained both in the filename and in the name metadata; so in my eyes that means this is a named dataset.

    -- Section 2 --

    -- Section 2.1 --

    -- Section 4 --

    == NITS ==

    -- Section 1 --

    -- Section 1.2 --

    -- Section 6 --
    A "," is missing.

---

From: "Eric Vyncke (evyncke)" <[email-masked]>
Date: Wed, 6 Oct 2021 09:26:16 +0000

Balázs,

It is reasonable not to update the document title at this stage (even if I slightly regret it).

For your last point, I always dislike having the same information twice as it is a risk to the consistency and could cause problem for the receiver when the filename and the meta-data do not agree.

Regards

-éric

On 06/10/2021, 11:03, "Balázs Lengyel" <balazs.lengyel=[email-masked]> wrote:

    Hello Eric,

    -----Original Message-----
    From: Eric Vyncke (evyncke) <evyncke=[email-masked]> 
    Sent: 2021. október 5., kedd 23:19
    To: Balázs Lengyel <[email-masked]>; The IESG <[email-masked]>; Benoit Claise <[email-masked]>
    Cc: [email-masked]; Kent Watsen <[email-masked]>; [email-masked]; [email-masked]
    Subject: Re: Éric Vyncke's No Objection on draft-ietf-netmod-yang-instance-file-format-19: (with COMMENT)

    Hello Balázs,

    Regards

    -éric

        Hello Eric,

        -----Original Message-----
        From: Éric Vyncke via Datatracker <[email-masked]> 
        Sent: 2021. október 5., kedd 13:27
        To: The IESG <[email-masked]>
        Cc: [email-masked]; [email-masked]; [email-masked]; Kent Watsen <[email-masked]>; [email-masked]
        Subject: Éric Vyncke's No Objection on draft-ietf-netmod-yang-instance-file-format-19: (with COMMENT)

        Regards,

        -éric

        == COMMENTS ==

        -- Section 1 --

    EV> thanks

        -- Section 1.1 --

        -- Section 2 --

        -- Section 2.1 --

        -- Section 4 --

        == NITS ==

        -- Section 1 --

        -- Section 1.2 --

        -- Section 6 --
        A "," is missing.